function fontResize(image,size)
	local w = image:width()
	local h = image:height()
	local result = Image.createEmpty(w * size, h * size)
	for x=0,w-1 do
		for y=0,h-1 do
			result:fillRect(x*size, y*size, size, size, image:pixel(x, y))
		end
	end
	return result
end

-- thanks to Shine for this
function fontRotate(image)
	local w = image:width()
	local h = image:height()
	local result = Image.createEmpty(h, w)
	for x=0,w-1 do
		for y=0,h-1 do
			result:pixel(h-y-1, x, image:pixel(x, y))
		end
	end
	return result
end

-- thanks to Shine for this
function printEdit(x, y, text, color, image, rotate, size)
	local w = string.len(text)
	local result = Image.createEmpty(w * 8, 8)
	result:print(0, 0, text, color)
	if rotate > 0 then
		rotate = rotate - 1
		for i=0,rotate do
			result = fontRotate(result)
		end
	end
	if size>1 then
		result = fontResize(result,size)
	end
	image:blit(x, y, result)
end
