--[[
///////////////////////////////////////////////////////////////////////////////
 'Filer'
 Copyright(c) 2005, ema.
///////////////////////////////////////////////////////////////////////////////
]]
-------------------------------------------------------------------------------
require "home/pad.lc"
require "home/twintail.lc"
require "home/editctrl.lc"
require "home/filer.lc"
-------------------------------------------------------------------------------
Editor = {
  BaseDir   = System.currentDirectory()
, KeyType   = 0
, OnWindows = string.find(System.currentDirectory(), "/cygdrive/")
, MenuList = {
    "Nouveau"
  , "Ouvrir"
  , "Enregistrer"
  , "Enregistrer sous "
  , "Fermer"
  , "USB active"
  , "Executer en lua"
  , "Quitter"
  }
  } 
dofile "home/ttlde.cfg"
dofile "home/ttlde.dic"
-------------------------------------------------------------------------------
function Editor.new(scr)
  if scr == nil then scr = screen end
  local c = setmetatable({
    Available  = true
  , ClipBoard  = ""
  , Target     = scr
  , iBuf       = 1
  , Buffers    = {}
  , FileName   = {}
  , GlobalState = {}
  , LoadedState = {}
  }, { __index = Editor })
  for Key, Value in pairs(_G) do
    c.GlobalState[Key] = Value
  end
  for Key, Value in pairs(_LOADED) do
    c.LoadedState[Key] = Value
 end 
 c:New()
  return c
end
-------------------------------------------------------------------------------
function Editor:RestoreState()
  _LOADED = {}
  result, err = pcall(result)
  for Key, Value in pairs(_G) do
    if Value ~= _G then
      _G[Key] = self.GlobalState[Key]
    end
  end
  for Key, Value in pairs(self.LoadedState) do
    _LOADED[Key] = Value
  end
  collectgarbage()
end
-------------------------------------------------------------------------------
function Editor:EditOneLine(msg, width, src)
  local tti = TwinTail.new(self.KeyType)
  local SubBuffer = EditControl.new(self)
  SubBuffer.MultiLine = false
  if src then
    SubBuffer.Buffer[1] = src
    SubBuffer.CurPos = string.len(src)+1
  end 
 while true do
    Pad:Update() 
   self:Draw()
    if Pad.R1 then
      local In = tti:Update()
      tti:Draw(screen, 392, 228)
      SubBuffer:Keyin(In)
    else
      SubBuffer:EditProc()
    end
    SubBuffer:DrawEditBox(width, msg)
    self:Flip()
    if not Pad.PressedX then
      if Pad.tRr then return SubBuffer.Buffer[1] end
      if Pad.tRd then return end
    end
  end
end
-------------------------------------------------------------------------------
function Editor:Confirm()
  if self.Buffers[self.iBuf].Modified then
    return self:MsgBox("Ne pas sauver?", 1) == 0
  else
    return true
  end
end
-------------------------------------------------------------------------------
function Editor:DrawBg()
  local this = self.Buffers[self.iBuf]
  local Target = self.Target
  Target:fillRect(0,   0, 480, 272, this.Colors.Bg)
  Target:fillRect(0,   0, 480,  12, this.Colors.Title)
  Target:fillRect(0, 268, 480,   4, this.Colors.Title)

  if not self.OnWindows then
    Target:print(448, 2,
      System.powerGetBatteryLifePercent().."%", this.Colors.Text)
    Target:print(392, 2,
      math.floor(System.getFreeMemory()/1024).."K", this.Colors.Text)
  end
  Target:print(8, 2, self.iBuf..":"..
    string.sub((this.FileName or "[untitled]"), -30)
      , this.Colors.Text)
end
-------------------------------------------------------------------------------
function Editor:Draw()
  self:DrawBg()
  self.Buffers[self.iBuf]:Draw()
end
-------------------------------------------------------------------------------
function Editor:MsgBox(msg, lv)
  local this = self.Buffers[self.iBuf]
  while true do
    Pad:Update()
    self:Draw()
    self.Target:fillRect(160, 100, 160, 12, this.Colors.Title)
    self.Target:fillRect(160, 112, 160, 88, this.Colors.Popup)
    self.Target:print(170, 120, msg, this.Colors.Text)
    self.Target:print(170, 150, "Rond = OK", this.Colors.Text)
    if lv>0 then self.Target:print(170, 160, "Croix  = Non", this.Colors.Text) end
    if lv>1 then self.Target:print(170, 170, "Carre = Annule", this.Colors.Text) end
    self:Flip()
   if Pad.tRr then return 0 end
    if lv>0 and Pad.tRd then return 1 end
    if lv>1 and Pad.tRl then return 2 end
  end
end
-------------------------------------------------------------------------------
function Editor:MenuMain(List, Title)
  local Scroll = 1
  local Sel=1
  local n=table.getn(List)
  local this = self.Buffers[self.iBuf]
  while true do
    Pad:Update()
    self:Draw()
    if Pad.tRd then return nil end
    if Pad.tRr then return Sel end
    Sel = Sel + Pad:GetVrep()
    if Sel < 1 then Sel = n end
    if Sel > n then Sel = 1 end
    if Scroll > Sel     then Scroll = Sel     end
    if Scroll < Sel - 8 then Scroll = Sel - 8 end
    self.Target:fillRect(120, 100, 240, 12, this.Colors.Title)
    self.Target:fillRect(120, 112, 240, 88, this.Colors.Popup)
    if Title then
      self.Target:print(124, 102, Title, this.Colors.Text)
    end
    for i=1,9 do
      local iItem = i+Scroll-1
      local item = List[iItem]
      if item then
        local col = this.Colors.Text
        if iItem == Sel then col = this.Colors.SelText end
        self.Target:print(130, 110+i*8, item, col)
      end
    end
    self:Flip()
  end
end
-------------------------------------------------------------------------------
function Editor:ExecLua()
  local result,err = loadstring(table.concat(self.Buffers[self.iBuf].Buffer, "\n"))
  if not result then
    self:EditOneLine("Compile error", 40, err)
  else
    local OrgDir = System.currentDirectory()
    result, err = pcall(result)
    System.currentDirectory(OrgDir)
    self:RestoreState()
    if not result then
      self:EditOneLine("Erreur d'excution ", 40, err)
    else
      self:MsgBox("fait.", 0)
    end
  end
end
-------------------------------------------------------------------------------
function Editor:ViewPicture(Name)
  local bg  = Image.createEmpty(480, 272)
  local pic = Image.load(Name)
  local w = 240 - pic:width()/2
  local h = 136 - pic:height()/2
  local x, y = 0, 0
  local c1 = Color.new(210, 210, 210)
  local c2 = Color.new(240, 240, 240)
  bg:fillRect(0, 0, 480, 272, c2)
  for i=0,464,16 do
    for j=0,256,16 do
      bg:fillRect(i, j, 8, 8, c1)
      bg:fillRect(i+8, j+8, 8, 8, c1)
    end
  end
  repeat
    Pad:Update()
    x = x + Pad:GetHrep()
    y = y + Pad:GetVrep()
    self.Target:blit(0, 0, bg, 0, 0, 480, 272, false)
    self.Target:blit(w+x, h+y, pic)
    self:Flip()
  until Pad.tRd
end
-------------------------------------------------------------------------------
function Editor:New()
  local t = EditControl.new(self)
  table.insert(self.Buffers, t)
  self.iBuf = table.getn(self.Buffers)
  return t
end
-------------------------------------------------------------------------------
function Editor:Open()
  local NewName = Filer()
  if NewName then
    if string.find(NewName, "[pP][nN][gG]$") or
       string.find(NewName, "[jJ][pP][gG]$") then
      self:ViewPicture(NewName)
    else
      self:New()
      self.Buffers[self.iBuf]:Load(NewName)
      self.Buffers[self.iBuf].FileName = NewName
    end
  end
end
-------------------------------------------------------------------------------
function Editor:Close()
  table.remove(self.Buffers, self.iBuf)
  self.iBuf = table.getn(self.Buffers)
  if self.iBuf == 0 then self:New() end
end
-------------------------------------------------------------------------------
function Editor:FileMenu()
  local Sel = self:MenuMain(self.MenuList, "Dossier")
  local this = self.Buffers[self.iBuf]
  if Sel==1 then self:New() end
  if Sel==2 then self:Open() end
  if Sel==3 then
    if not this.FileName then
      Sel=4
    else
      this:Save(this.FileName)
    end
  end
  if Sel==4 then
    local NewName =
      self:EditOneLine("Nom du fichier", 30, this.FileName)
    if NewName then
      this:Save(NewName)
      this.FileName = NewName
    end
  end
  if Sel==5 then
    if self:Confirm() then self:Close() end
  end
  if Sel==6 then
    System.usbDiskModeActivate()
    self:MsgBox("USB connecting", 0)
    System.usbDiskModeDeactivate()
  end
  if Sel==7 then
    if self:MsgBox("Sure?", 1) == 0 then
      self:ExecLua()
    end
  end
  if Sel==8 then
    if self:Confirm() then
      if self:MsgBox("Quitter?", 1) == 0 then
        self.Available = false
      end
    end
  end
end
-------------------------------------------------------------------------------
function Editor:PluginMenu()
  local this = self.Buffers[self.iBuf]
  local ef
  local Dir = "/home/plugin"
  while true do
    local FileList = {}
    local PluginNameList = {}
    if self.OnWindows then
      FileList = {
        {}, {}
      , {name="1000_rechercher....lua"}
      , {name="2000_Sauter a....lua"}
      , {name="3000_Changer Color  Scheme.lua"}
      }
    else
      FileList = System.listDirectory(self.BaseDir .. Dir)
    end
    -- remove "." et ".."
    table.remove(FileList, 1)
    table.remove(FileList, 1)
    table.sort(FileList,
      function(a, b)
        if a.directory == b.directory then return a.name < b.name end
        return b.directory
      end
    )
    for idx,file in FileList do
      if file.directory then
        table.insert(PluginNameList, "/" .. file.name)
      else
        local ul  = string.find(file.name, "_") or 0
        local dot = string.find(file.name, "lua$") or 0
        table.insert(PluginNameList, string.sub(file.name, ul+1, dot-2))
      end
    end
    local Sel = self:MenuMain(PluginNameList, "Plugin")
    if not Sel then return end 
   if FileList[Sel].directory then
      Dir = Dir .. PluginNameList[Sel]
    else
      local fln = self.BaseDir .. Dir .. "/" .. FileList[Sel].name
      local func, err = loadfile(fln)
      if not func then
        self:EditOneLine("Eurreur de compilation", 40, err)
      else
        dofile(fln)
        PluginFunc(self, this)
      end
      return
    end
  end
end
-------------------------------------------------------------------------------
function Editor:Flip()
  if not self.OnWindows then
    if Timer then
      if not timer then
        timer = Timer.new()
        timer:start()
        OldTick = timer:time()
      end
      local dt = timer:time() - OldTick
      if dt < 16 then screen.waitVblankStart() end
      OldTick = timer:time()
    end
  else
    screen.waitVblankStart()
  end
  screen.flip()
end
-------------------------------------------------------------------------------
function Editor:SelectGlobal()
  local White = Color.new(255, 255, 255)
  local Red   = Color.new(255,   0,   0)
  local Yellow= Color.new(255, 255,   0)
  local Cyan  = Color.new(  0, 255, 255)
  local Path  = {}
  local ret
  local FullPath
  local pfxmode = true
  local Prefix = { [false]=".", [true]=":" }
  local SortProc = function(a, b)
    if (a.Type == b.Type) then return a.Name < b.Name end
    if a.Type == "table" then return true  end
    if b.Type == "table" then return false end
    if a.Type == "function" then return true  end
    if b.Type == "function" then return false end
    return a.Type < b.Type
  end
  while not ret do
    local Sel = 1
    local tbl = _G
    local ValList = { }
    local change = false
    local nFile = 0
    local Scroll = 0
    FullPath = ""
    for Lv, Name in pairs(Path) do
      if Name == "[true]" then
        tbl = tbl[true]
      elseif Name == "[false]" then
        tbl = tbl[false]
      elseif string.find(Name, "[", 1, true) then
        tbl = tbl[tonumber(string.sub(Name, 2, -2))]
      else
        tbl = tbl[Name]
        if FullPath ~= "" then Name = "." .. Name end
      end
      FullPath = FullPath .. Name
    end
    if tbl == nil then ret = "" ; break end
    for Key, Value in pairs(tbl) do
      local elem = { Key=Key, Name=Key, Type=type(Value) }
      if type(Key) == "string" then
        if string.find(Key, "_") ~= 1 then
          table.insert(ValList, elem)
          nFile = nFile + 1
        end
      elseif type(Key) == "number" then
        elem.Name = "[" .. Key .. "]"
        table.insert(ValList, elem)
        nFile = nFile + 1
      elseif type(Key) == "boolean" then
        if Key then
          elem.Name = "[true]"
        else
         elem.Name = "[false]"
        end
        table.insert(ValList, elem)
        nFile = nFile + 1
      end
    end
    table.sort(ValList, SortProc)
    while not change do
      Pad:Update()
      self.Target:clear()
      self.Target:print(0, 0, "Variable path   = ["..FullPath.."]", White)
      self.Target:print(0, 8, "Function prefix = ["..Prefix[pfxmode].."]", White)
      Sel = Sel + Pad:GetVrep()
      if Sel < 1 then Sel = nFile end
      if Sel > nFile then Sel = 1 end
      if Scroll > Sel - 10 then Scroll = Sel - 10 end
      if Scroll < Sel - 20 then Scroll = Sel - 20 end
      if Pad.tLl or Pad.tLr then pfxmode = not pfxmode end
      if Pad.tRu then ret = "" ; break end
      if Pad.tRd then
        if table.getn(Path) == 0 then
          ret=""
        else
          table.remove(Path)
        end
        change = true
      end
      for i=0, 30 do
        local iFile = i+Scroll
        local elem = ValList[iFile]
        local y = i*8 + 16
        if elem then
          local col
          local Type = elem.Type
          local Name = elem.Name
          if Type == "table" then
            if Pad.tRr and iFile == Sel then
              table.insert(Path, Name)
              change = true
            end
            col = Cyan
          elseif Type == "function" then
            if Pad.tRr and iFile == Sel then
              ret = Name .. "()"
              change = true
            end
            col = Yellow
          else
            if Pad.tRr and iFile == Sel then
              ret = Name
              change = true
            end
            col = White
          end
          if Pad.R1 and Pad.tRl and iFile == Sel then
            tbl[elem.Key] = nil
            change = true
          end
          if iFile == Sel then col = Red end
          self.Target:print(8, y, Name, col)
          self.Target:print(380, y, "[" .. Type .. "]", col)
        end
      end
      screen.waitVblankStart()
      screen.flip()
    end
  end
  if ret ~= "" then
    if not string.find(ret, "[", 1, true) then
      local pfx = "."
      if string.find(ret, "()", 1, true) then
        pfx = Prefix[pfxmode]
      end
      if FullPath ~= "" then ret = pfx .. ret end
    end
    local this = self.Buffers[self.iBuf]
    this:InsertString(FullPath .. ret)
    this.CopyInfo.eLine = this.CurLine
    this.CopyInfo.ePos  = this.CurPos
    this:UpdateSelection()
  end
end
-------------------------------------------------------------------------------
function Editor:QuickInput()
  local Category, Sel = 1, 1
  local this = self.Buffers[self.iBuf]
  local moved = false
  this.CopyInfo.sLine = this.CurLine
  this.CopyInfo.sPos  = this.CurPos
  this.CopyInfo.eLine = this.CurLine
  this.CopyInfo.ePos  = this.CurPos
  this:UpdateSelection()
  this:SetUndo()
  while true do
    Pad:Update()
    self:Draw()
    if not Pad.Ru then
      if not moved then self:SelectGlobal() end
      break
    end
    local h = Pad:GetHrep()
    local v = Pad:GetVrep()
    if h ~= 0 then
      local n = table.getn(self.Dictionary)
      Category = Category + h
      if Category < 1 then Category = n end
      if Category > n then Category = 1 end
      Sel, v = 0, 1
      moved = true
    end
    if v ~= 0 then
      local n = table.getn(self.Dictionary[Category])
      Sel = Sel + v
      if Sel < 1 then Sel = n end
      if Sel > n then Sel = 1 end
      this:DeleteSelection()
      this:InsertString(self.Dictionary[Category][Sel])
      this.CopyInfo.eLine = this.CurLine
      this.CopyInfo.ePos  = this.CurPos
      this:UpdateSelection()
      moved = true
    end
    self:Flip()
  end
end
-------------------------------------------------------------------------------
-- Main routine
do
  local tti = TwinTail.new(Editor.KeyType)
  local editor = Editor.new()
  local bufchg = false
  editor.Buffers[editor.iBuf]:Load(editor.BaseDir .. "/home/readme.txt")
  while editor.Available do
    Pad:Update()
    editor:Draw()
    if Pad.R1 then
      local In = tti:Update()
      tti:Draw(screen, 392, 228)
      editor.Buffers[editor.iBuf]:Keyin(In)
      if Pad.tSt then screen:save(editor.BaseDir .. "/screenshot.png") end
    else
      if not Pad.L1 and Pad.tRu then
        editor:QuickInput()
      end
      if Pad.tSt then editor:FileMenu() end
      if Pad.Sl then
        local n = table.getn(editor.Buffers)
        local h = Pad:GetHrep()
        if h ~= 0 then
          bufchg = true
          editor.iBuf = editor.iBuf + h
          if editor.iBuf < 1 then editor.iBuf = n end
          if editor.iBuf > n then editor.iBuf = 1 end
        end
      elseif Pad.rSl then
        if not bufchg then editor:PluginMenu() end
        bufchg = false
      else
        editor.Buffers[editor.iBuf]:EditProc()
      end
    end
    editor:Flip()
  end
end